<?php 

function dump($x){
	echo "<pre>";
	print_r($x);
	echo "</pre>";
}

class ControllerExtensionPaymentpaybullpayment extends Controller {
	private $error = array(); 

	public function recurringCancel() {
	    return "";
	}

	function generateRandomString($length = 10) {
	    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
	    $charactersLength = strlen($characters);
	    $randomString = '';
	    for ($i = 0; $i < $length; $i++) {
	        $randomString .= $characters[rand(0, $charactersLength - 1)];
	    }
	    return $randomString;
	}

	public function index() {
		//$this->load->library('paybullpayment');

		$this->language->load('extension/payment/paybullpayment');
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$configs = $this->request->post;
			//dump($configs['paybullpayment_installments']);exit;
			if( isset($configs['paybullpayment_installments']) AND count($configs['paybullpayment_installments']) )
			$configs['paybullpayment_installments'] = strval( implode(',', $configs['paybullpayment_installments']) );
			
			$x = $this->model_setting_setting->editSetting('paybullpayment', $configs);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/payment/paybullpayment', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_test'] = $this->language->get('text_test');
		$data['text_live'] = $this->language->get('text_live');		
		$data['entry_status'] = $this->language->get('entry_status');		
		$data['entry_cardsave'] = $this->language->get('entry_cardsave');		
		$data['entry_api_key'] = $this->language->get('entry_api_key');
		$data['entry_env_mode'] = $this->language->get('entry_env_mode');
		$data['entry_installment_list'] = $this->language->get('entry_installment_list');
		$data['entry_order_status'] = $this->language->get('entry_order_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['entry_merchant_key'] = $this->language->get('entry_merchant_key');
		$data['entry_app_key'] = $this->language->get('entry_app_key');
		$data['entry_app_secret'] = $this->language->get('entry_app_secret');
		$data['entry_merchant_id'] = $this->language->get('entry_merchant_id');
		$data['entry_sale_web_hook_key'] = $this->language->get('entry_sale_web_hook_key');
		$data['entry_refund_web_hook_key'] = $this->language->get('entry_refund_web_hook_key');
		$data['entry_recurring_web_hook_key'] = $this->language->get('entry_recurring_web_hook_key');
		$data['entry_environment'] = $this->language->get('entry_environment');
		$data['entry_provision'] = $this->language->get('entry_provision');
		$data['text_connected'] = $this->language->get('text_connected');
		$data['text_notconnected'] = $this->language->get('text_notconnected');
		$data['entry_installment_text'] = $this->language->get('entry_installment_text');
		$data['entry_debug'] = $this->language->get('entry_debug');
		

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['login'])) {
			$data['error_login'] = $this->error['login'];
		} else {
			$data['error_login'] = '';
		}

		if (isset($this->error['key'])) {
			$data['error_key'] = $this->error['key'];
		} else {
			$data['error_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => false
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_payment'),
			'href'      => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('extension/payment/paybullpayment', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$data['action'] = HTTPS_SERVER . 'index.php?route=extension/payment/paybullpayment&token=' . $this->session->data['token'];

		$data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token'];

		$data['paybullpayment_cardsave'] = 
		isset($this->request->post['paybullpayment_cardsave']) ? $this->request->post['paybullpayment_cardsave'] : $this->config->get('paybullpayment_cardsave');
		$data['paybullpayment_merchant_key'] = 
		isset($this->request->post['paybullpayment_merchant_key']) ? $this->request->post['paybullpayment_merchant_key'] : $this->config->get('paybullpayment_merchant_key');
		$data['paybullpayment_app_key'] = 
		isset($this->request->post['paybullpayment_app_key']) ? $this->request->post['paybullpayment_app_key'] : $this->config->get('paybullpayment_app_key');
		$data['paybullpayment_app_secret'] = 
		isset($this->request->post['paybullpayment_app_secret']) ? $this->request->post['paybullpayment_app_secret'] : $this->config->get('paybullpayment_app_secret');
		$data['paybullpayment_merchant_id'] = 
		isset($this->request->post['paybullpayment_merchant_id']) ? $this->request->post['paybullpayment_merchant_id'] : $this->config->get('paybullpayment_merchant_id');
		$data['paybullpayment_sale_web_hook_key'] = 
		isset($this->request->post['paybullpayment_sale_web_hook_key']) ? $this->request->post['paybullpayment_sale_web_hook_key'] : $this->config->get('paybullpayment_sale_web_hook_key');
		$data['paybullpayment_refund_web_hook_key'] = 
		isset($this->request->post['paybullpayment_refund_web_hook_key']) ? $this->request->post['paybullpayment_refund_web_hook_key'] : $this->config->get('paybullpayment_refund_web_hook_key');
		$data['paybullpayment_recurring_web_hook_key'] = 
		isset($this->request->post['paybullpayment_recurring_web_hook_key']) ? $this->request->post['paybullpayment_recurring_web_hook_key'] : $this->config->get('paybullpayment_recurring_web_hook_key');
		$data['paybullpayment_environment'] = 
		isset($this->request->post['paybullpayment_environment']) ? $this->request->post['paybullpayment_environment'] : $this->config->get('paybullpayment_environment');
		$data['paybullpayment_provision'] = 
		isset($this->request->post['paybullpayment_provision']) ? $this->request->post['paybullpayment_provision'] : $this->config->get('paybullpayment_provision');
		$data['paybullpayment_debug'] = 
		isset($this->request->post['paybullpayment_debug']) ? $this->request->post['paybullpayment_debug'] : $this->config->get('paybullpayment_debug');
		$data['paybullpayment_status'] = 
		isset($this->request->post['paybullpayment_status']) ? $this->request->post['paybullpayment_status'] : $this->config->get('paybullpayment_status');
		$data['paybullpayment_order_status_id'] = 
		isset($this->request->post['paybullpayment_order_status_id']) ? $this->request->post['paybullpayment_order_status_id'] : $this->config->get('paybullpayment_order_status_id');
		$data['paybullpayment_sort_order'] = 
		isset($this->request->post['paybullpayment_sort_order']) ? $this->request->post['paybullpayment_sort_order'] : $this->config->get('paybullpayment_sort_order');
		$data['paybullpayment_installments'] = 
		isset($this->request->post['paybullpayment_installments']) ? $this->request->post['paybullpayment_installments'] : explode(",", $this->config->get('paybullpayment_installments'));
		$data['paybullpayment_token'] = 
		isset($this->request->post['paybullpayment_token']) ? $this->request->post['paybullpayment_token'] : $this->config->get('paybullpayment_token');

		if ( $data['paybullpayment_token'] == '' ){
			$data['paybullpayment_token'] = $this->generateRandomString(10);
		}
		
		$data['paybullpayment_sale_web_hook_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/paybullpayment/webhook&do=sale&token=' . $data['paybullpayment_token'];
		$data['paybullpayment_refund_web_hook_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/paybullpayment/webhook&do=refund&token=' . $data['paybullpayment_token'];
		$data['paybullpayment_recurring_web_hook_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/paybullpayment/webhook&do=recurring&token=' . $data['paybullpayment_token'];

		
		$data['connected'] = 0;
		$installmentOptions = [];
        if( $this->config->get('paybullpayment_merchant_key') != ""){
        	
            $paybull = new paybullpayment(
                $this->config->get('paybullpayment_app_key'),
                $this->config->get('paybullpayment_app_secret'),
                $this->config->get('paybullpayment_merchant_key'),
                $this->config->get('paybullpayment_sale_web_hook_key'),
                $this->config->get('paybullpayment_recurring_web_hook_key'),
                $this->config->get('paybullpayment_environment'),
                $this->config->get('paybullpayment_debug')
            );

            $paybullInstallments = $paybull->getStoreInstallments();

            if($paybullInstallments["status"] == "success"){
            	$data['connected'] = 1;
                $availableInstallments = $paybullInstallments["data"];
                foreach($availableInstallments as $installment){
                    if($installment != 1)
                    	$installmentOptions[] = $installment;
                }
            }
        }

        $data['available_installments'] = $installmentOptions;

		$this->load->model('localisation/order_status');
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/paybullpayment', $data));
	}

	public function install() {
		$this->load->model('extension/payment/paybullpayment');
		$this->model_extension_payment_paybullpayment->install();
	}

	public function uninstall() {
		$this->load->model('extension/payment/paybullpayment');
		$this->model_extension_payment_paybullpayment->uninstall();
	}

	protected function validate() {
		return true;
		if (!$this->user->hasPermission('modify', 'payment/paybullpayment')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['paybullpayment_merchant_name']) {
			$this->error['login'] = $this->language->get('error_login');
		}

		if (!$this->request->post['paybullpayment_merchant_key']) {
			$this->error['key'] = $this->language->get('error_key');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}	
	}


}
?>