<script src="./catalog/view/javascript/paybullpayment.js"></script>
<style type="text/css">
        input::-webkit-outer-spin-button,
input::-webkit-inner-spin-button {
    /* display: none; <- Crashes Chrome on hover */
    -webkit-appearance: none;
    margin: 0; /* <-- Apparently some margin are still there even though it's hidden */
}

input[type=number] {
    -moz-appearance:textfield; /* Firefox */
}
</style>
<?php if(isset($paybullerror) AND $paybullerror != '') { ?>

    <div class="alert alert-danger"><?php echo $paybullerror; ?></div>

<?php }else{ ?> 

    <?php if($mode == 'redirect'){ ?>
    <div id="modulepaybullpayment" class="row wrapper-row"> <!--ROW -->
        <?php echo $text_wait; ?>
        <script>
            setTimeout(function(){
                window.location.href = "<?php echo $redirect_url2; ?>"
            }, 3000);
        </script>
    </div>
    <?php }elseif($mode == 'form'){ ?>

        <form action="<?php echo $form_url; ?>" id="payment_paybull-payment-form" autocomplete="off" method="post" >
            <?php if($card_store_feature == 1){ ?>

            <div class="form-group row ml-0 mr-0 0">
                <label class="col-md-4 form-control-label required">
                    <?php echo $text_use_stored_card; ?>
                </label>
                <div class="col-md-6">
                    <?php if(count($savedCards)){ ?>
                        <select id="payment_paybull_card" name="useCard" class="form-control">
                            <option value="0"><?php echo $no_use_saved_card; ?></option>
                            <?php foreach($savedCards as $key => $card ){ ?>
                                <option value="<?php echo $key; ?>"><?php echo $card; ?></option>
                            <?php } ?> 
                        </select>
                    <?php }else{ ?> 
                        <?php echo $text_no_have_stored_cards; ?>
                    <?php } ?>
                </div>
                <div class="col-md-2">
                    <a href="javascript:;" data-url="<?php echo $entry_delete_url; ?>" class="btn btn-primary" id="deleteMyCard" class="" style="display:none"><?php echo $entry_delete; ?></a>
                </div>
            </div>
            <hr>
            <?php } ?>
            <div class="form-group row ml-0 mr-0 cardForm">
                <label class="col-md-4 form-control-label required">
                    <?php echo $entry_cc_owner; ?>
                </label>
                <div class="col-md-8">
                    <input class="form-control alpha-only" id="paybullCardOwner" name="cardOwner" type="text" value="" maxlength="20"
                           >
                </div>
            </div>
            <div class="form-group row ml-0 mr-0 cardForm">
                <label class="col-md-4 form-control-label required">
                    <?php echo $entry_cc_number; ?>
                </label>
                <div class="col-md-8">
                    <input type="number" class="form-control" id="paybullCardPan" name="pan" onkeyup="getInstallment(this)" pattern=".{14,16}">
                </div>
                <div class="col-md-3 form-control-comment">
                </div>
            </div>
            <div class="form-group row ml-0 mr-0 cardForm">
                <label class="col-md-4 form-control-label required">
                    <?php echo $entry_cc_expire_date; ?>
                </label>
                <div class="col-md-8">
                    <div class="col-xs-3 col-md-3 p-0" style="float:left; display:block">
                        <select name="expiryMonth" id="expiryMonth" class="form-control">
                            <?php foreach($months as $month){ ?> 
                                <option value="<?php echo $month; ?>"><?php echo $month; ?></option>
                            <?php } ?>
                        </select>
                    </div>
                    <div class="col-xs-4 col-md-4 p-0" style="float:left; display:block">
                        <select id="expiryYear" name="expiryYear" class="form-control">
                            <?php foreach($years as $year){ ?> 
                                <option value="<?php echo $year; ?>"><?php echo $year; ?></option>
                            <?php } ?>
                        </select>
                    </div>
                </div>
                <div class="col-md-3 form-control-comment">
                </div>
            </div>

            <div class="form-group row ml-0 mr-0 cardForm">
                <label class="col-md-4 form-control-label required">
                    <?php echo $entry_cc_cvv2; ?>
                </label>
                <div class="col-md-8">
                    <input style="width:60px" class="form-control" id="cvv" name="cvv" type="text" value="" maxlength="4"
                           >
                </div>
            </div>

            <div class="form-group row ml-0 mr-0" style="">
                <label class="col-md-4 form-control-label required">
                    <?php echo $entry_installment; ?>
                </label>
                <div class="col-md-8">
                    <select id="payment_paybull_taksit" name="installmentCount" class="form-control ">
                        <option value="1"><?php echo $pesin_text; ?></option>
                    </select>
                </div>
            </div>
            <?php if($paybull_show_3d_option == 1){ ?>
                <div class="form-group row ml-0 mr-0 cardForm" style="">
                    <label class="col-md-4 form-control-label required">
                        <?php echo $text_use_3d; ?>
                    </label>
                    <div class="col-md-8">
                        <input type="checkbox" name="use3d" id="use3d" class="">
                    </div>
                </div>
            <?php } ?>
            <?php if($card_store_feature == 1){ ?>
            <div class="form-group row ml-0 mr-0 cardForm" style="">
                <label class="col-md-4 form-control-label required">
                    <?php echo $text_card_save; ?>
                </label>
                <div class="col-md-8">
                    <input type="checkbox" name="saveCard" id="saveCard" class="">
                </div>
            </div>
            <?php } ?>
            <input type="hidden" name="payment_paybull_total" id="payment_paybull_total" value="<?php echo $total; ?>">

            <div class="form-group row ml-0 mr-0" style="">
                <label class="col-md-4 form-control-label required">
                    
                </label>
                <div class="col-md-8">
                    <input type="submit" id="paybullSubmit" class="btn btn-primary btn-submit" name="submitForm" value="<?php echo $make_payment; ?>">
                </div>
            </div>

        </form>

    <?php } ?>
    <?php } ?>
